#include "accessor.h"

#include <string.h>



Accessor::Accessor(fileid_t fileid, offset_t size)
: _size(size), fileid(fileid)
{
}

/* Return the size of the file. */

offset_t Accessor::get_size()
{
    return _size;
}

/* Update the size of the file. */

void Accessor::set_size(offset_t size)
{
    _size = size;
}

/* Perform any closing operation on the file. */

void Accessor::close()
{
}

/* Perform any opening operation on the file. */

void Accessor::open()
{
}

/* Data transfer methods. */

void Accessor::fill(Flexpage *flexpage)
{
    /* Filling completely beyond the end of file should produce an empty
       flexpage. This could potentially be a shared read-only flexpage that
       would be replaced by an independent writable flexpage if ever written. */

    if (flexpage->base_offset < _size)
        fill_populated(flexpage);
    else
        memset((void *) flexpage->base_addr, 0, flexpage->size);
}

void Accessor::flush(Flexpage *flexpage)
{
    /* Flushing completely beyond the end of file should discard the
       flexpage. */

    if (flexpage->base_offset < _size)
        flush_populated(flexpage);
}

/* Data transfer helper methods. */

void Accessor::fill_populated(Flexpage *flexpage)
{
}

void Accessor::flush_populated(Flexpage *flexpage)
{
}

// vim: tabstop=4 expandtab shiftwidth=4
